require 'jwt'
require 'json'

require "herdst_servicecall/railtie"
require "herdst_servicecall/configurator"
require "herdst_servicecall/caller"
require "herdst_servicecall/receiver"
require "herdst_servicecall/middleware"
require "herdst_servicecall/request"
require "herdst_servicecall/response"
require "herdst_servicecall/responder"
require "herdst_servicecall/responder_error"
require "herdst_servicecall/mocker" if (ENV["RAILS_ENV"] == "test") || (ENV["WORKER_ENV"] == "test")


module HerdstServicecall
    
    
    @@config = Configurator.new
    @@caller = Caller.new(@@config)
    @@receiver = Receiver.new(@@config)
    
    
    def self.config
        @@config
    end

    
    def self.receive(token, data)
        @@receiver.receive(token, data)
    end
    
    
    def self.call(service_name, event_name, data)
        @@caller.call(service_name, event_name, data)
    end
    
    
    def self.setup(&block)
        yield @@config if block_given?
    end
    
    
end
